      subroutine cnvl_ht_dp(x,y,n)
      implicit none
      integer n,nh,n2,i
      double precision x(n),y(n),fx,x1,x2,half

!   cnvl_ht produces the hartley transform of x *** y
!    from the individual transforms of x and y
!     (the *** denotes convolution)

!******* NOTE NOTE:  the output overwrites x  **************


      n2 = n + 2
      nh = n/2
      half = 0.5d0
      fx = sqrt(dble(n))
      x(1) = fx*y(1)*x(1)
      x(nh+1) = fx*y(nh+1)*x(nh+1)
      do i = 2,nh
       x1 = y(i)*x(i)    - y(n2-i)*x(n2-i) 
       x2 = y(i)*x(n2-i) + y(n2-i)*x(i)
       x(i) = half*fx*( x2 + x1 )
       x(n2-i) = half*fx*( x2 - x1 )
      enddo
      return
      end
