      module dotprod

       use rarith  !  contains smparith
       use mpmodule
       use mpmodulev
       implicit none
        
       interface operator(.dot.)
         module procedure dott,dp_dott,cpx_dott,dcpx_dott,idott,&
         &smp_dott,rat_dott,mtrx_dott,mtrxvec_dott,mp_dott,rcpx_dott,&
         ddcpx_dott,dmtrx_dott,dmtrxvec_dott
       end interface

       character(len=1),target,allocatable :: smpdot_c(:),ratdotn_c(:),&
       & ratdotd_c(:)
        
       contains        

       function mtrx_dott(a,b)
       real,intent(in)  :: a(:,:,:),b(:,:,:)
       real :: mtrx_dott(size(a,1),size(b,2))
       integer i
        mtrx_dott = 0.
        if( size(a,2) == size(b,1) )then
         do i = 1,min(size(a,3),size(b,3))
          mtrx_dott = mtrx_dott + &
          & matmul(a(1:size(a,1),1:size(a,2),i),b(1:size(b,1),1:size(b,2),i))
         enddo
        endif
       return
       end function mtrx_dott
        
       function mtrxvec_dott(a,b)
       real,intent(in)  :: a(:,:,:),b(:,:)
       real :: mtrxvec_dott(size(a,1))
       integer i
        mtrxvec_dott = 0.
        if( size(a,2) == size(b,1) )then
         do i = 1,min(size(a,3),size(b,2))
          mtrxvec_dott = mtrxvec_dott + &
          & matmul(a(1:size(a,1),1:size(a,2),i),b(1:size(b,1),i))
         enddo
        endif
       return
       end function mtrxvec_dott

       function dmtrx_dott(a,b)
       double precision,intent(in)  :: a(:,:,:),b(:,:,:)
       double precision :: dmtrx_dott(size(a,1),size(b,2))
       integer i
        dmtrx_dott = 0.
        if( size(a,2) == size(b,1) )then
         do i = 1,min(size(a,3),size(b,3))
          dmtrx_dott = dmtrx_dott + &
          & matmul(a(1:size(a,1),1:size(a,2),i),b(1:size(b,1),1:size(b,2),i))
         enddo
        endif
       return
       end function dmtrx_dott
        
       function dmtrxvec_dott(a,b)
       double precision,intent(in)  :: a(:,:,:),b(:,:)
       double precision :: dmtrxvec_dott(size(a,1))
       integer i
        dmtrxvec_dott = 0.
        if( size(a,2) == size(b,1) )then
         do i = 1,min(size(a,3),size(b,2))
          dmtrxvec_dott = dmtrxvec_dott + &
          & matmul(a(1:size(a,1),1:size(a,2),i),b(1:size(b,1),i))
         enddo
        endif
       return
       end function dmtrxvec_dott
        
       integer function idott(a,b)
        integer,intent(in)  :: a(:)
        integer,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
        idott = dot_product(a(1:mab),b(1:mab))
        return
       end function idott

       real function dott(a,b)
        real,intent(in)  :: a(:)
        real,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
        dott = dot_product(a(1:mab),b(1:mab))
        return
       end function dott

       type(mp_real) function mp_dott(a,b)
        type(mp_real),intent(in)  :: a(:),b(:)
        integer mab,i
        mab = min(size(a,1),size(b,1))
        mp_dott = '0.'
        do i = 1,mab
         mp_dott = mp_dott + a(i)*b(i)
        enddo
        return
       end function mp_dott

       double precision function dp_dott(a,b)
        double precision,intent(in)  :: a(:)
        double precision,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
        dp_dott = dot_product(a(1:mab),b(1:mab))
        return
       end function dp_dott

       complex function cpx_dott(a,b)
        complex,intent(in)  :: a(:)
        complex,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
!   the conjg(a) undoes the conjg that the dotproduct internal routine does
        cpx_dott = dot_product(conjg(a(1:mab)),b(1:mab))
        return
       end function cpx_dott

       complex function rcpx_dott(a,b)
        real,intent(in)  :: a(:)
        complex,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
!   the conjg(a) undoes the conjg that the dotproduct internal routine does
        rcpx_dott = dot_product(a(1:mab),b(1:mab))
        return
       end function rcpx_dott

       double complex function dcpx_dott(a,b)
        double complex,intent(in)  :: a(:)
        double complex,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
!   the conjg(a) undoes the conjg that the dotproduct internal routine does
        dcpx_dott = dot_product(conjg(a(1:mab)),b(1:mab))
        return
       end function dcpx_dott

       double complex function ddcpx_dott(a,b)
        double precision,intent(in)  :: a(:)
        double complex,intent(in)  :: b(:)
        integer mab
        mab = min(size(a,1),size(b,1))
!   the conjg(a) undoes the conjg that the dotproduct internal routine does
        ddcpx_dott = dot_product(a(1:mab),b(1:mab))
        return
       end function ddcpx_dott

       type(smprec) function smp_dott(a,b) result(w)
       type(smprec),intent(in):: a(:),b(:)
       integer i,nab

       if( .not. allocated(smpdot_c) )then
        allocate(smpdot_c(8192))
       endif

       w%m=>smpdot_c(1)
       w%x=8192

       nab = min(size(a,1),size(b,1))

       w = zero_smp

       do i = 1,nab
        w = w + a(i)*b(i)
       enddo

       return
       end function smp_dott

       type(rational) function rat_dott(a,b) result(w)
       type(rational),intent(in):: a(:),b(:)
       integer ratmax_dotprod,i,nab

       if( .not. allocated(ratdotn_c) )then
        allocate(ratdotn_c(8192),ratdotd_c(8192))
       endif

       nab = min(size(a,1),size(b,1))

       w%nxn = 0
       w%nxd = 0
       w%n%m=>ratdotn_c(1)
       w%d%m=>ratdotd_c(1)
       w%n%x = 8192
       w%d%x = 8192

       w%n = zero_smp
       w%d = one_smp

!  increase accumulator accuracy for now
       if( ratmax > 0 )then
        ratmax_dotprod = ratmax
        ratmax = ratmax + 2*(ratmax/5) + 2
       endif

       do i = 1,nab
        w = w + a(i)*b(i)
       enddo

!   restore original accuracy, and adjust w to ratmax size
       if( ratmax > 0 )then
        ratmax = ratmax_dotprod
        call euclid(w)
       endif
        

       return
       end function rat_dott


      end module dotprod
