#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <complex.h>

static  int *J;
static double fx;

void fht_dp(double x[], complex double trig[], int n)
{ int sm,m,nh,i,j,k,l,le,le1,le2,lk,ku,ib,nsm,nm,r,nh1;
 double xm,xnm,xnsm,xsm;
 void sw_fht_dp(int i,int j,double x[]);
 if( n==1 ){return;};
 J = (int *) malloc(4*n);
 m=1.4426953*log((double)n);
 nh=(n>>1);nh1=nh+1;
 fx = 1./sqrt((double)n);
/* scale input */
 for(i=0;i<=n-1;i++){x[i]*=fx;}
/* ruis-yong bit reversal algorithm */
 J[0]=0;J[1]=nh;sw_fht_dp(1,nh,x);
 for(i=2,l=2,r=(nh>>1);r>1;l<<=1,r>>=1)
 {for(k=0;k<l;k+=2,i+=2)
  {j=J[i]=J[k]+r;
   if(i<j){sw_fht_dp(i,j,x);sw_fht_dp(i+nh1,j+nh1,x);
           sw_fht_dp(i+1,j+nh,x);sw_fht_dp(i+nh,j+1,x);}
   else if(i==j){sw_fht_dp(i+1,j+nh,x);}
  }
 }
 le=1;
 for(l=1;l<=m;l++)
 {le1=le;le2=(le1>>1);le<<=1;
  for(i=0;i<=n-1;i+=le)
  {xm=x[i];xnm=x[le1+i];x[i]=xm+xnm;x[le1+i]=xm-xnm;};
  if( le2 > 0 )
  {ku=(lk=n/le);
   for(j=1;j<=le2;j++)
   {ib=0;
    for(i=j;i<=n-1;i+=le)
    {nsm = ib+le1-i;nm=i+le1;sm = nsm+le1;
     xm=x[i];xnsm=x[nsm];xnm=x[nm];xsm=x[sm];
     x[i]=xm + (creal(trig[ku])*xnm+cimag(trig[ku])*xsm);
     x[nm]=xm - (creal(trig[ku])*xnm+cimag(trig[ku])*xsm);
     x[nsm]=xnsm - (creal(trig[ku])*xsm-cimag(trig[ku])*xnm);
     x[sm]=xnsm + (creal(trig[ku])*xsm-cimag(trig[ku])*xnm); 
     ib+=(le<<1);
    }
    ku+=lk;
   }
  }
 }
 free(J);
 return;
}

void sw_fht_dp(int i, int j, double x[])
{ double t;
  t=x[i];x[i]=x[j];x[j]=t;
  return;
}
