      integer function golub(a,m,n,x,b,nb,atau,rtau)
      use dotprod
      implicit none
!      a(m,n) b(m,nb)
!      golub solves for x(n,) such that (b-ax)**2 is minimum
!      method of g. golub, numerische mathematik 7,206-216(65)
      INTEGER n,nb,m,k,jb,nx,j,i
      real(4) a(m,n),b(m,nb),x(n,nb),u(m),fact,smm,rrtau
      real(8) :: qai,qsmm,qbi,qsm,qsigma,qne=1.,qero=0.
      real(4), optional :: atau,rtau
      integer ix(n)
 
      rrtau = 5.2684d-9 !  0.5*sqrt(dlamch('epsilon')
      if( present(rtau) )then
       rrtau = rtau
      endif
 
      ix = (/(k,k=1,n)/)
      jb = 0
       if(n == m)then
        nx=n-1
       elseif(m > n )then
        nx=n
       else
        nx=m
       endif
       do k=1,nx
        qsmm = sum(real(a(k:m,ix(k)),8)**2)
        jb = k
        do j=k+1,n
         qsm = sum(real(a(k:m,ix(j)),8)**2)
         if(qsm > qsmm)then
          jb=j
          qsmm=qsm
         endif
        enddo
        j=ix(jb)
        ix(jb)=ix(k)
        ix(k)=j
        qai=a(k,ix(k))
        qsigma=sign(sqrt(qsmm),qai)
        if( qsigma /= qero )then
         qbi=sqrt(qne+qai/qsigma)
         u(k)=qbi
         fact=qne/(qsigma*qbi)
         u(k+1:m) = fact*a(k+1:m,ix(k))
         do j=k,n
          fact = u(k:m) .dot. a(k:m,ix(j))
          a(k:m,ix(j)) = a(k:m,ix(j)) - fact*u(k:m)
         enddo
         do jb=1,nb
          fact = u(k:m) .dot. b(k:m,jb)
          b(k:m,jb) = b(k:m,jb) - fact*u(k:m)
         enddo
        endif
       enddo
      golub = 0
      do i=n,1,-1
       if( i <= m )then
        if( abs(a(i,ix(i))) > tau() )then
         do jb=1,nb
          smm = x(ix(i+1:n),jb) .dot. a(i,ix(i+1:n))
          x(ix(i),jb)=(b(i,jb)-smm)/a(i,ix(i))
         enddo
         cycle
        endif
       endif
       golub = golub + 1
       x(ix(i),1:nb) = 0.
      enddo
      return
 
      contains
 
      double precision function tau()
       if( present(atau) )then
        tau = atau
       else
        if( i > 1 )then
         tau = rrtau*sqrt(sum(a(1:i-1,ix(i))**2)/(i-1))
        else
         tau = 0.
        endif
       endif
       return
      end function tau
 
      end function golub
