      module icsestuff
       integer mxcolumns,mxfiles,mxshifts,mxehifts,ncfiles,ncolumns,&
       & nsfiles,nshifts,icpr,ispr,iepr,nefiles,nehifts
       integer, allocatable :: columns(:,:),shifts(:,:),&
       & ehifts(:,:),shc(:,:),ehc(:,:)
       character(len=65536) cstring,sstring,estring
      end module icsestuff

      subroutine icse(rname,buffer,i,gotarg,narg,istat)

      use icsestuff
      implicit none

      character(len=65536) buffer
      character(len=*)rname
      integer i,narg,istat
      logical gotarg

      interface
       integer function column_parse(string,columns)
        character(*), intent(in) ::  string
        integer, intent(out) ::  columns(0:,1:)
       end function column_parse
      end interface

      istat = 0

      ncfiles = 0
      ncolumns = 0
      nsfiles = 0
      nshifts = 0
      nefiles = 0
      nehifts = 0

      if( buffer == "-c" )then
       i = i + 1
       if( i > narg )then
        write(0,*)trim(rname),' error: missing column(s)'
        istat = 9761
        return
       endif
       call getarg(i,cstring)

       ncfiles = 0
       ncolumns = 0

        do while ( .not. allocated(columns)   .or. &
       &   ncfiles > mxfiles .or. ncolumns > mxcolumns )

        if( allocated(columns) )then
         deallocate(columns)
         mxfiles = ncfiles
         mxcolumns = ncolumns
        endif

!   columns(0,i) = total number of column entries in columns(1:mxcolumns,i)
!   columns(1:columns(0,i),i) gives columns to be read in file i
        allocate(columns(0:mxcolumns,mxfiles))
        columns(0:mxcolumns,1:mxfiles) = 0

!   column entries for different files are separated by ":"
        icpr = column_parse(cstring,columns)
        ncfiles = mod(icpr,32768)
        ncolumns = icpr/32768

       enddo

       i = i + 1
       gotarg = .false.
      elseif( buffer == "-s" )then
        i = i + 1
       if( i > narg )then
        write(0,*)trim(rname),' error: missing shift(s)'
        istat = 9762
        return
       endif
       call getarg(i,sstring)

       nsfiles = 0
       nshifts = 0

        do while ( .not. allocated(shifts)   .or. &
       &   nsfiles > mxfiles .or. nshifts > mxshifts )

        if( allocated(shifts) )then
         deallocate(shifts)
         mxfiles = nsfiles
         mxshifts = nshifts
        endif

!   shifts(0,i) = total number of shift entries in shifts(1:mxshifts,i)
!   shifts(1:shifts(0,i),i) gives shifts to be read in file i
        allocate(shifts(0:mxshifts,mxfiles))
        shifts(0:mxshifts,1:mxfiles) = 0

!   shift entries for different files are separated by ":"
        ispr = column_parse(sstring,shifts)
        nsfiles = mod(ispr,32768)
        nshifts = ispr/32768

       enddo

       i = i + 1
       gotarg = .false.
      elseif( buffer == "-e" )then
        i = i + 1
       if( i > narg )then
        write(0,*)trim(rname),' error: missing endshift(s)'
        istat = 9763
        return
       endif
       call getarg(i,estring)

       nefiles = 0
       nehifts = 0

        do while ( .not. allocated(ehifts)   .or. &
       &   nefiles > mxfiles .or. nehifts > mxehifts )

        if( allocated(ehifts) )then
         deallocate(ehifts)
         mxfiles = nefiles
         mxehifts = nehifts
        endif

!   ehifts(0,i) = total number of ehift entries in ehifts(1:mxehifts,i)
!   ehifts(1:ehifts(0,i),i) gives ehifts to be read in file i
        allocate(ehifts(0:mxehifts,mxfiles))
        ehifts(0:mxehifts,1:mxfiles) = 0

!   ehift entries for different files are separated by ":"
        iepr = column_parse(estring,ehifts)
        nefiles = mod(iepr,32768)
        nehifts = iepr/32768

       enddo

       i = i + 1
       gotarg = .false.
      endif

      return
      end subroutine icse
