       subroutine ludc(a,piv,m)
!  algorithm taken from Golub & Loan, pp 93,94,118
!   much more accurate than my previous attempt using
!   the Crout algorithm, as done in Numerical Recipes
       implicit none
       integer m,piv(2,m-1),i,k
       real a(m,m),xx
       interface
        subroutine xcol(a,c1,c2)
        integer c1,c2
        real a(:,:)
        end subroutine xcol
        subroutine xrow(a,r1,r2)
        integer r1,r2
        real a(:,:)
        end subroutine xrow
       end interface
! p 118
       do k = 1,m-1

        piv(1:2,k) = maxloc(abs(a(k:m,k:m))) + (/k-1,k-1/)
        call xrow(a,piv(1,k),k)
        call xcol(a,piv(2,k),k)

        xx = 0.
        if( abs(a(k,k)) > 0. )then
         xx = 1./a(k,k)
        endif
! p 93
        a(k+1:m,k) = a(k+1:m,k)*xx
! p 94
        do i=k+1,m
         a(k+1:m,i) = a(k+1:m,i) - a(k+1:m,k)*a(k,i)
        enddo

       enddo
       return

       end subroutine ludc
