      use rdline
      use icsestuff
      implicit none
      real, allocatable :: u(:,:),t(:,:),v(:,:),&
      & rsid(:,:),aerr(:),rss(:),x(:,:),s(:,:)
      real, allocatable :: vplot(:,:)
      real atau,rtau,zero,one,td
      real, allocatable :: mn(:),sig(:),fx(:)
      real tp
      integer, allocatable :: lgth(:)
      character(len=1) :: linesw = "y"
      character(len=256) cfmt
      integer iunit,ninc,nalloc,mfiles,ifile,sstat,nrhs,irhs,ilhs, &
      & ifl,jfl,i,j,k,narg,nxu,istat,nvec,icl,nread,lvv, &
      & ll,ounit,tunit1,tunit2,kx,m,ncols,kz,vdate(8),rkd,myoud,lbuff
      character(len=10) :: delimiter="none",dtstrng
      character(len=65536) buffer,buffer1,buffer2
      character(len=65536), allocatable :: fnames(:),tnames(:)
      logical stin,gotarg,lplot,lrsid
      character(len=10), allocatable :: column_info(:)
      integer n,mxcolumn_info
      logical :: rsidcalc=.true.

      interface
      subroutine mnstd(x,mean,sdev,tprob,w,sw,rtrmm,pcttrmm,trmm,down)
       real, intent(in) :: x(:)
       real, optional, intent(in) :: pcttrmm,w(:),sw(:),rtrmm
       integer,optional,intent(in) :: trmm
       real, intent(out) :: mean,sdev
       real, intent(out) :: tprob
       logical, optional :: down
      end subroutine mnstd
       integer function mtxinv(a,atau,rtau)
        real a(:,:)
        real, intent(in), optional :: atau,rtau
       end function mtxinv
             subroutine blkcmprs(strng)
              character(len=*)strng
             end subroutine blkcmprs
             subroutine blankrmv(strng)
              character(len=*)strng
             end subroutine blankrmv
       integer function column_parse(string,columns)
        character(*), intent(in) ::  string
        integer, intent(out) ::  columns(0:,1:)
       end function column_parse
             integer function lusolve(a,m,b,n,piv,atau,rtau)
              integer m,n
	      integer, optional :: piv(2,m-1)
	      real, optional :: atau,rtau
              real a(m,m),b(m,n)
             end function lusolve
        integer function golub(a,m,n,x,b,nb,atau,rtau)
         integer m,n
         real a(m,n),b(m,nb),x(n,nb)
         real, optional :: atau,rtau
        end function golub
      end interface

      narg = iargc()

      nrhs = 1
      irhs = 0
      ilhs = 0
      ninc = 500
      nalloc = 500
      mxfiles = 10
      mxcolumns = 10
      mxshifts = 10
      mxehifts = 10
      cstring = " "
      sstring = " "
      estring = " "
      ll = 0
      kz = 0
      kx = 0
      n = 0
      atau = -1.d0
      rtau = -1.d0
      allocate(fnames(1:mxfiles))

      ounit = 10
      tunit1 = 11
      tunit2 = 12
      lrsid = .false.
      lplot = .false.



      nxu = 0
      ncolumns = 0
      ncfiles = 0
      nsfiles = 0
      nefiles = 0
      stin = .true.  !   stin true means we have stdin
      myoud = 8

      i = 1
      gotarg = .false.

      do while ( i <= narg )

       if( .not. gotarg )then
        call getarg(i,buffer)
       gotarg = .true.
       endif

       if( buffer == "-odg" )then
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no digits specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,buffer)
        read(buffer,'(i30)',iostat=istat)myoud
         if( istat /= 0 .or. myoud <= 0 )then
          write(0,*)'lusolve error: invalid output precision ',myoud
          deallocate(fnames)
          if( allocated(columns) )then
           deallocate(columns)
          endif
          if( allocated(shifts) )then
           deallocate(shifts)
          endif
          if( allocated(ehifts) )then
           deallocate(ehifts)
          endif
         endif
        i=i+1
        gotarg = .false.
       elseif( buffer == "-P" )then
        linesw = "e"
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-C" )then
        linesw = "s"
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-ta" )then
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no atau specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,buffer)
        read(buffer,'(d30.0)',iostat=istat)atau
        if( istat /= 0 )then
         write(0,*)'lusolve error: invalid atau'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-rhs" )then
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no nrhs specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,buffer)
        read(buffer,'(i30)',iostat=istat)nrhs
        if( istat /= 0 )then
         write(0,*)'lusolve error: invalid nrhs'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-tr" )then
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no rtau specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,buffer)
        read(buffer,'(d30.0)',iostat=istat)rtau
        if( istat /= 0 )then
         write(0,*)'lusolve error: invalid rtau'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-o" )then
        lrsid = .true.
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no residual file specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,buffer)
        open(ounit,file=buffer,status="unknown",action="write",iostat=istat)
        if( istat /= 0 )then
         write(0,*)'lusolve error opening residual file ',trim(buffer)
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-f" )then
        stin = .false.
        i = i + 1
       if( i > narg )then
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
        write(0,*)'lusolve error: missing the file name'
        call exit(1)
       endif
       nxu = nxu + 1
       if( nxu /= 1 )then
        write(0,*)'lusolve error: more than one type of file specification'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
        call exit(1)
       endif
       call getarg(i,fnames(nxu))
       i = i + 1
       gotarg = .false.
       elseif( buffer == "-d" )then
        i = i + 1
        if( i > narg )then
         write(0,'(a)')&
         & 'lusolve error: no delimiter specified'
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
        call getarg(i,delimiter)
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-ff" )then
        stin = .false.
        i = i + 1
       if( i > narg )then
        write(0,*)'lusolve error: missing set of file names'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
        call exit(1)
       endif
       nxu = 0
       gotarg = .false.
       do while ( i <= narg )
        call getarg(i,buffer)
        if( buffer(1:1) /= "-" .and. buffer(1:2) /= "--" )then
         nxu = nxu + 1
         call reallocatenames(nxu)
         fnames(nxu) = buffer
         i = i + 1
        else
         gotarg = .true.
         exit
        endif
       enddo
       elseif( buffer == "-p" )then
        lplot = .true.
        i = i + 1
        gotarg = .false.
       elseif( buffer == "-xf" )then
        i = i + 1
       if( i > narg )then
        write(0,*)'lusolve error: missing set of extra file names'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
        call exit(1)
       endif
       gotarg = .false.
       do while ( i <= narg )
        call getarg(i,buffer)
        if( buffer(1:1) /= "-" .and. buffer(1:2) /= "--" )then
         nxu = nxu + 1
         fnames(nxu) = buffer
         i = i + 1
        else
         gotarg = .true.
         exit
        endif
       enddo
       elseif( buffer == "-c" .or. buffer == "-s" .or. buffer == "-e")then
        call icse('lusolve',buffer,i,gotarg,narg,istat)
        if( istat > 0 )then
         write(0,*)'lusolve parse error with ',buffer(1:2)
         deallocate(fnames)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
       else
        write(0,*)'lusolve error: unrecognized option: ',trim(buffer)
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
       call exit(1)
       endif

      enddo

      if( stin )then
       mfiles = nxu + 1
      else
       mfiles = nxu
      endif

      zero = 0.d0
      one = 1.d0

      if( ncfiles > mfiles )then
       write(0,*)'lusolve error: columns specified for too many files'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
       call exit(1)
      endif

      if( mfiles > mxfiles )then
       mxfiles = mfiles
       if( allocated(columns) )then
        deallocate(columns)
        mxfiles = mfiles
        allocate(columns(0:mxcolumns,1:mxfiles))
        columns(0:mxcolumns,1:mxfiles) = 0
        icpr = column_parse(cstring,columns)
        ncfiles = mod(icpr,32768)
        ncolumns = icpr/32768
       endif
       if( allocated(shifts) )then
        deallocate(shifts)
        allocate(shifts(0:mxfiles,1:mxfiles))
        shifts(0:mxshifts,1:mxshifts) = 0
        ispr = column_parse(sstring,shifts)
        nsfiles = mod(ispr,32768)
        nshifts = ispr/32768
       endif
       if( allocated(ehifts) )then
        deallocate(ehifts)
        allocate(ehifts(0:mxfiles,1:mxfiles))
        ehifts(0:mxehifts,1:mxehifts) = 0
        iepr = column_parse(estring,shifts)
        nefiles = mod(iepr,32768)
        nehifts = iepr/32768
       endif
      endif

      if ( ncfiles /= 0 .and. ncfiles /= mfiles )then
       write(0,*)'lusolve error: number of files and columns don''t agree'
       call exit(1)
      endif

      if ( nsfiles /= 0 .and. nsfiles /= mfiles )then
       write(0,*)'lusolve error: number of files and shifts don''t agree'
       call exit(1)
      endif

      if ( nefiles /= 0 .and. nefiles /= mfiles )then
       write(0,*)'lusolve error: number of files and endshifts don''t agree'
       call exit(1)
      endif

!   set up the column defaults when there were null or no specifications
      if( .not. allocated(columns) )then
       allocate(columns(0:1,mfiles))
       ncolumns = 1
       do i = 1,mfiles
        columns(0:1,i) = 1
       enddo
      endif

      ncols = sum(columns(0,1:mfiles))

      if( .not. allocated(shifts) )then
       allocate(shifts(0:ncols,mfiles))
       nshifts = ncols
       shifts(0,1:mfiles) = 0
       do i = 1,mfiles
        shifts(0,i) = columns(0,i)
        shifts(1:shifts(0,i),i) = 0
       enddo
      endif

      if( .not. allocated(ehifts) )then
       allocate(ehifts(0:ncols,mfiles))
       nehifts = ncols
       ehifts(0,1:mfiles) = 0
       do i = 1,mfiles
        ehifts(0,i) = columns(0,i)
        ehifts(1:ehifts(0,i),i) = huge(i)-1
       enddo
      endif

      nshifts = sum(shifts(0,1:mfiles))
      nehifts = sum(ehifts(0,1:mfiles))

      nvec = sum(columns(0,1:mfiles))

      if( nshifts /= ncols )then
       write(0,*)'lusolve error: number of startshifts and columns don''t match'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
       call exit(1)
      endif

      if( nehifts /= ncols )then
       write(0,*)'lusolve error: number of endshifts and columns don''t match'
        deallocate(fnames)
        if( allocated(columns) )then
         deallocate(columns)
        endif
        if( allocated(shifts) )then
         deallocate(shifts)
        endif
        if( allocated(ehifts) )then
         deallocate(ehifts)
        endif
       call exit(1)
      endif


      allocate(u(1:nalloc,nvec),lgth(nvec),&
      &shc(0:ncols,mfiles),ehc(0:ncols,mfiles))

      shc(0:ncols,1:mfiles) = 0
      ehc(0:ncols,1:mfiles) = 0
      lgth(1:nvec) = 0


      jfl = 0

      do ifl = 1,mfiles

        if( ifl == 1 .and. stin )then
        iunit = 5
       else
        iunit = 9
        if( stin )then
         ifile = ifl -1
        else
         ifile = ifl
        endif
        open(iunit,file=fnames(ifile),status="old",action="read",iostat=istat)
        linenumber(iunit) = 0
        if( istat /= 0 )then
         write(0,*)'lusolve error opening file ',trim(fnames(ifile))
         deallocate(fnames,u)
         if( allocated(columns) )then
          deallocate(columns)
         endif
         if( allocated(shifts) )then
          deallocate(shifts)
         endif
         if( allocated(ehifts) )then
          deallocate(ehifts)
         endif
         call exit(1)
        endif
       endif

       if( delimiter /= "none" )then
        delim_rdline(iunit) = delimiter
       endif

       do icl = 1,columns(0,ifl)

       if( columns(1,ifl) == 0 )then

         nread = readline(iunit)  !   free format
         lvv = 0
         do while ( nread > 0 .and. lvv <= ehifts(1,ifl) )
          do j = 1,niflds
           if( lvv+j > shifts(1,ifl) .and. lvv+j <= ehifts(1,ifl)+1 )then
            call reallocate(lvv+j)
            read(input_line(bif(j):eif(j)),'(d30.0)',iostat=istat)td
            if( istat /= 0 )then
             write(0,*)'lusolve error reading file,line,field ',&
             & ifl,linenumber(iunit),j
             call exit(1)
            endif
           endif
           u(lvv+j,jfl+1) = td
          enddo
          lvv = lvv + niflds
          nread = readline(iunit)
         enddo
        jfl = jfl + 1
        lgth(jfl) = lvv

       else

        if( icl == 1 )then !  only read the first time through
         ll = linenumber(iunit)
         nread = readline(iunit)
         lvv = 0
          do while ( nread > 0 )
           lvv = lvv + 1
           do j = 1,columns(0,ifl)
            if( ll < shifts(j,ifl) )then
             shc(j,ifl) = shc(j,ifl) + &
             & min(linenumber(iunit)-(ll+1),shifts(j,ifl)-ll)
            endif
            if( ll < ehifts(j,ifl) )then
             ehc(j,ifl) = ehc(j,ifl) + &
             & min(linenumber(iunit)-(ll+1),ehifts(j,ifl)-ll)
            endif
            call reallocate(lvv)
!            write(*,*)'ln sh eh niflds ',&
!            & linenumber(iunit),shifts(j,ifl),ehifts(j,ifl),niflds
            if( linenumber(iunit) <= shifts(j,ifl) &
            &                .or.  &
            &   linenumber(iunit) > ehifts(j,ifl) + 1 )then
             u(lvv,jfl+j) = zero
            else
!             write(*,*)'ccolumns(j,ifl) ',ccolumns(j,ifl)
             if( ccolumns(j,ifl) <= niflds )then
              read(input_line(bif(ccolumns(j,ifl)):eif(ccolumns(j,ifl))),&
              &'(d30.0)',iostat=istat)td
              if( istat /= 0 )then
               write(0,*)'lusolve error reading file,line,field ',&
               & ifl,linenumber(iunit),ccolumns(j,ifl)
               call exit(1)
              endif
              u(lvv,jfl+j) = td
!              write(*,*)'read ',u(lvv,jfl+j)
             else
              write(0,*)'lusolve error: missing field, line ',linenumber(iunit),&
              & ', file ',ifl
              call exit(1)
             endif
            endif
           enddo
           ll = linenumber(iunit)
           nread = readline(iunit)
           if( linenumber(iunit) > maxval(ehifts(1:columns(0,ifl),ifl)+1) )then
            nread = -1
           endif
          enddo
         lgth(jfl+1:jfl+columns(0,ifl)) = lvv
         jfl = jfl + columns(0,ifl)
        endif
       endif

       if( iunit /= 5 )then
        close(iunit)
       endif

       enddo
      enddo


      deallocate(fnames)

!      write(*,*)'data in'


!   all the data is now in; first, we need to use the shifts
!   in order to line the data up


   shifts(1:ncols,1:mfiles) = shifts(1:ncols,1:mfiles)-shc(1:ncols,1:mfiles)
   ehifts(1:ncols,1:mfiles) = ehifts(1:ncols,1:mfiles)-ehc(1:ncols,1:mfiles)

   deallocate(shc,ehc)

       i = 0
       do ifl = 1,mfiles
        do j = 1,ehifts(0,ifl)
         i = i + 1
          lgth(i) = min(lgth(i),ehifts(j,ifl)+1)
        enddo
       enddo


       i = 0
       do ifl = 1,mfiles
        do j = 1,shifts(0,ifl)
         i = i + 1
         if( shifts(j,ifl) > 0 )then
          do k = 1,lgth(i)-shifts(j,ifl)
           u(k,i) = u(k+shifts(j,ifl),i)
          enddo
          lgth(i) = lgth(i) - shifts(j,ifl)
         endif
        enddo
       enddo

!   the vectors are now lined up

!  n will be the number of data points
!     write(*,*)'nrhs ',nrhs

      n = minval(lgth(1:nvec))
      kz = ncols
      kx = kz - nrhs  ! kx=number of independent variables
      if( n < kx )then
       write(0,*)&
       & 'lusolve error: number of equations less than number of independent variables'
       deallocate(u,lgth,columns,shifts,ehifts)
       call exit(1)
      endif

!      write(*,*)'allocating v'

      allocate(v(n,kz))

!   rearrange the data; store weights if needed; generate column_info
      allocate(column_info(kz))
      mxcolumn_info = 0

      do m = 1,n
       i = 0
       irhs = 0
       ilhs = 0
       do ifl = 1,mfiles
        do j = 1,columns(0,ifl)
         i = i + 1
          if( irhs < nrhs )then
           irhs = irhs + 1
           v(m,kx+irhs) = u(m,i)
!           write(*,*)'irhs m v ',irhs,m,v(j,kx+irhs)
          else
           ilhs = ilhs + 1
           if( m == 1 )then
            write(column_info(ilhs),'(i4,":",i5)')ifl,ccolumns(j,ifl)
            call blankrmv(column_info(ilhs))
!            write(*,*)'ilhs column_info ',ilhs,trim(column_info(ilhs))
            mxcolumn_info = max(len_trim(column_info(ilhs)),mxcolumn_info)
           endif
           v(m,ilhs) = u(m,i)
!           write(*,*)'ilhs m v ',ilhs,m,v(j,ilhs)
          endif
        enddo
       enddo
      enddo

!      write(*,*)'done massaging data'

      if( ilhs /= kx )then
       write(0,*)'lusolve fatal error, ilhs /= kx'
       deallocate(u,v,lgth,columns,shifts,ehifts)
       call exit(1)
      endif

      if( irhs /= nrhs )then
       write(0,*)'lusolve fatal error, irhs /= nrhs'
       deallocate(u,v,lgth,columns,shifts,ehifts)
       call exit(1)
      endif

!   don't need original data anymore; save original v
!      write(*,*)'saving original data'
      u(1:n,1:kz) = v(1:n,1:kz)
      allocate(x(1:kx,1:nrhs))
!  we are going to change gears now

        allocate(mn(kx),sig(kx),fx(kx))
        do i = 1,kx
         call mnstd(v(1:n,i),mn(i),sig(i),tp)
         fx(i) = abs(mn(i))+1000.*sig(i)
         if( fx(i) == 0. )then
          fx(i) = 1.
         endif
         fx(i) = 1./fx(i)
         v(1:n,i) = v(1:n,i)*fx(i)
        enddo
        deallocate(mn,sig)
  






      allocate(rsid(1:n,1:nrhs),rss(nrhs),aerr(nrhs))

      if( kx == n )then
       x(1:n,1:nrhs) = v(1:n,kx+1:kz)
       if( atau > zero )then
        rkd=lusolve(v(1:n,1:ilhs),n,x(1:n,1:nrhs),nrhs,atau=atau)
       elseif( rtau > zero )then
        rkd=lusolve(v(1:n,1:ilhs),n,x(1:n,1:nrhs),nrhs,rtau=rtau)
       else
        rkd=lusolve(v(1:n,1:ilhs),n,x(1:n,1:nrhs),nrhs)
       endif
       if( rkd > 0 )then
        write(*,*)'rank deficiency = ',rkd
       endif
       do i = 1,nrhs
        x(1:kx,i) = x(1:kx,i)*fx(1:kx)
        rsid(1:n,i) = u(1:n,kx+i) - matmul(u(1:n,1:kx),x(1:kx,i))
        rss(i) = sum(rsid(1:n,i)**2)
       enddo
       rsidcalc = .false.
      elseif( n > kx )then ! overspecified problem
       if( atau > zero )then
        istat = golub(v(1:n,1:kx),n,kx,&
        & x(1:kx,1:nrhs),v(1:n,kx+1:kz),nrhs,atau=atau)
       elseif( rtau > zero )then
        istat = golub(v(1:n,1:kx),n,kx,&
        & x(1:kx,1:nrhs),v(1:n,kx+1:kz),nrhs,rtau=rtau)
       else
        istat = golub(v(1:n,1:kx),n,kx,&
        & x(1:kx,1:nrhs),v(1:n,kx+1:kz),nrhs)
       endif
       if( istat > 0 )then
        write(*,*)'rank deficiency = ',istat
       endif
       do j = 1,nrhs
        x(1:kx,j) = x(1:kx,j)*fx(1:kx)
        rss(j) = sum(v(kx+1-istat:n,kx+j)**2)
       enddo
      else
       write(0,*)'lusolve fatal error, not enough equations'
       deallocate(x,u,v,lgth,columns,shifts,ehifts,column_info)
       call exit(1)
      endif


       if( lrsid )then
        if( rsidcalc )then
         do i = 1,nrhs
          rsid(1:n,i) = u(1:n,kx+i) - matmul(u(1:n,1:kx),x(1:kx,i))
         enddo
        endif
        write(cfmt,'("(i8,",i12,"g",i6,".",i6,")")')nrhs,myoud+8,myoud
        call blankrmv(cfmt)
        do i = 1,n
         write(*,cfmt)i,rsid(i,1:nrhs)
        enddo
        close(ounit)
       endif

       deallocate(rsid)

       aerr(1:nrhs) = sqrt(rss(1:nrhs)/n)

     if( n > kx )then
        allocate(s(kx,kx),t(kx,kx))
        t(1:kx,1:kx) = v(1:kx,1:kx)
        istat = mtxinv(t(1:kx,1:kx))
        s(1:kx,1:kx) = matmul(t(1:kx,1:kx),transpose(t(1:kx,1:kx)))
           do j = 1,kx
            s(1:kx,j) = fx(j)*s(1:kx,j)
           enddo
           do i = 1,kx
            s(i,1:kx) = s(i,1:kx)*fx(i)
           enddo
        deallocate(t)
        write(cfmt,'("(",i8,"(g",i6,".",i6,",1x,a,1x,g",i6,".",i6,",1x,""||""))")')&
        & nrhs,myoud+8,myoud,myoud+8,myoud
        call blankrmv(cfmt)
        do i = 1,kx
         write(buffer,cfmt)(x(i,j),"+-",sqrt(rss(j)*s(i,i)/(n-kx)),j=1,nrhs)
         call blkcmprs(buffer)
         lbuff = len_trim(buffer)
         write(*,'(3x,a,2x,a)')trim(column_info(i)),buffer(1:lbuff-3)
        enddo
        deallocate(s)
     else
        write(cfmt,'("(",i8,"g",i6,".",i6,")")')nrhs,myoud+8,myoud
        call blankrmv(cfmt)
       do i = 1,kx
        write(buffer,cfmt)x(i,1:nrhs)
        call blkcmprs(buffer)
        write(*,'(3x,a,2x,a)')trim(column_info(i)),trim(buffer)
       enddo
     endif
        write(cfmt,'("(a,1x,",i8,"(g",i6,".",i6,"))")')nrhs,myoud+8,myoud
        call blankrmv(cfmt)
        write(*,cfmt)'    average error in rhs',aerr(1:nrhs)


         deallocate(rss,fx)
         if( allocated(s) )then
          deallocate(s)
         endif

      if( lplot )then
       allocate(vplot(n,2*nrhs))
       do i = 1,nrhs
        vplot(1:n,i) = u(1:n,kx+i)
        vplot(1:n,nrhs+i) = matmul(u(1:n,1:kx),x(1:kx,i))
       enddo
       call date_and_time(values=vdate)
       write(dtstrng,'(i10)')&
       &vdate(5)*1000000+vdate(6)*10000+vdate(7)*100+vdate(8)
       dtstrng = adjustl(dtstrng)
       buffer1 = "/temp/dplot.temp."//trim(dtstrng)//".inp"
       buffer2 = "/temp/dplot.temp."//trim(dtstrng)//".dat"
       open(tunit1,file=buffer1,status="unknown",action="write")
       open(tunit2,file=buffer2,status="unknown",action="write")
       write(tunit1,'(i4)')2*nrhs
       do i = 1,2*nrhs
        write(tunit1,'(a,1x,i4)')trim(buffer2),i
       enddo
       write(tunit1,'(a)')linesw
       write(tunit1,'(2i10)')1,n
       close(tunit1)
       write(cfmt,'("(",i12,"g16.8)")')nrhs+nrhs
       call blankrmv(cfmt)
       do i=1,n
        write(tunit2,cfmt)vplot(i,1:2*nrhs)
       enddo
       close(tunit2)
       sstat = system("xterm -e /home/mike/bin/dplot "//trim(buffer1)&
       &//" 2>/dev/null")
!       if( sstat /= 0 )then
!         write(0,'(a)')'dplot failed'
!       endif
       deallocate(vplot)
      endif


      deallocate(aerr,v,u,x,column_info,lgth,columns,shifts,ehifts)


      call exit(0)


      contains

       subroutine reallocate(newsize)
       integer newsize,mxsize
       if( newsize > nalloc )then
         mxsize=max(nalloc+ninc,newsize)
        allocate(t(nalloc,nvec))
        t(1:nalloc,1:nvec) = u(1:nalloc,1:nvec)
        deallocate(u)
        allocate(u(mxsize,nvec))
        u(1:nalloc,1:nvec) = t(1:nalloc,1:nvec)
        u(nalloc+1:mxsize,1:nvec) = zero
        deallocate(t)
        nalloc = mxsize
       endif
       return
       end subroutine reallocate

       subroutine reallocatenames(newsize)
       integer newsize,mxsize
       if( newsize > mxfiles )then
       mxsize=max(mxfiles+mxfiles,newsize)
       allocate(tnames(mxfiles))
       tnames(1:mxfiles) = fnames(1:mxfiles)
       deallocate(fnames)
       allocate(fnames(1:mxsize))
       fnames(1:mxfiles) = tnames(1:mxfiles)
       deallocate(tnames)
       mxfiles = mxsize
       endif
       return
       end subroutine reallocatenames

       integer function ccolumns(j,ifl)
         integer j,ifl
          ccolumns = columns(j,ifl)
          if( columns(j,ifl) < 0 )then
           ccolumns = niflds + 1 + columns(j,ifl)
          endif
         return
        end function ccolumns
      end
