      module datecompare
       implicit none
       type datemdy
        character(len=20)d
       end type datemdy

       interface operator ( .eq. )
        module procedure date_eq
       end interface

       interface operator ( .ne. )
        module procedure date_ne
       end interface

       interface operator ( .gt.  )
        module procedure date_gt
       end interface

       interface operator ( .lt.  )
        module procedure date_lt
       end interface

       interface operator ( .ge.  )
        module procedure date_ge
       end interface

       interface operator ( .le. )
        module procedure date_le
       end interface

      contains

       logical function date_eq(ai,bi)
       type(datemdy), intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_eq = .false.
         return
        endif
        date_eq = ( a == b )
        return
       end function date_eq

       logical function date_ne(ai,bi)
       type(datemdy), intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_ne = .false.
         return
        endif
        date_ne = ( a /= b )
       return
       end function date_ne

       logical function date_gt(ai,bi)
       type(datemdy),intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_gt = .false.
         return
        endif
        date_gt = ( a > b )
        return
       end function date_gt

       logical function date_lt(ai,bi)
       type(datemdy),intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_lt = .false.
         return
        endif
        date_lt = ( a < b )
        return
       end function date_lt

       logical function date_ge(ai,bi)
       type(datemdy),intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_ge = .false.
         return
        endif
        date_ge = ( a >= b )
        return
       end function date_ge

       logical function date_le(ai,bi)
       type(datemdy),intent(in) :: ai,bi
       integer(kind=8) a,b
        a = fixdate_mtp(ai)
        b = fixdate_mtp(bi)
        if( a == -huge(a) .or. b == -huge(a) )then
         date_le = .false.
         return
        endif
        date_le = ( a <= b )
        return
       end function date_le

       integer(kind=8) function fixdate_mtp(a)
!  fix leading zeros in months or days, and convert to integer(kind=8)
        type(datemdy) a
        character(len=20)fixa
        integer(kind=8) a1,a2,la,ly,iy,ir
        integer(kind=4) istat
        la = len_trim(a%d)
        a1 = index(a%d,'/')
        a2 = index(a%d,'/',back=.true.) 
        if( a1 == 0 )then
         if( a%d(1:la) == "nodatenone" )then
          fixdate_mtp = -huge(a1)
         elseif( a%d(1:1) == "-")then
          read(a%d(1:la-4),'(i30)',iostat=istat)iy
!  take care of those cases when a date string is not initiallized properly
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
          read(a%d(la-3:la),'(i30)',iostat=istat)ir
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
          fixdate_mtp=10000*iy+ir
         else
          read(a%d(1:la),'(i30)',iostat=istat)fixdate_mtp
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
         endif
         return
        endif
        ly=la-a2
        fixa(1:ly)=a%d(a2+1:la)
        if( a1 == 2 )then
         fixa(ly+1:ly+1)="0"
         fixa(ly+2:ly+2)=a%d(1:a1-1)
        else
         fixa(ly+1:ly+2)=a%d(1:a1-1)
        endif
        if( a2-a1 == 2 )then
         fixa(ly+3:ly+3)="0"
         fixa(ly+4:ly+4)=a%d(a1+1:a1+1)
        else
         fixa(ly+3:ly+4)=a%d(a1+1:a1+2)
        endif
        if( fixa(1:1) == "-" )then
!  year is negative
         read(fixa(1:ly),'(i30)',iostat=istat)iy
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
!  month and day is positive
         read(fixa(ly+1:ly+4),'(i30)',iostat=istat)ir
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
!  add them together
         fixdate_mtp = 10000*iy + ir
        else
         read(fixa(1:ly+4),'(i30)',iostat=istat)fixdate_mtp
          if( istat /= 0 )then
           fixdate_mtp=-huge(a1)
           return
          endif
        endif
       return
       end function fixdate_mtp

       
      end module datecompare
