      subroutine mnstd(xi,mean,sdev,tprob,wi,swi,rtrmm,pcttrmm,trmm,down)
      use mrank
      implicit none
      INTEGER ntrmm
      REAL, external ::  qrobt
      real, intent(in) :: xi(:)
      real, optional, intent(in) :: wi(:),swi(:),rtrmm,pcttrmm
      integer,optional,intent(in) :: trmm
      real, intent(out) :: mean,sdev,tprob
      integer cnt,ndata,cnd
      double precision sum1,sum2,sumw,swi2
      real, allocatable :: x(:),w(:),sw(:)
      logical, optional :: down
      logical dwn
 
      ndata = size(xi,1)

      dwn = .false.
      if( present(down) )then
       dwn = down
      endif
 
!  start trmm branch, trmm false
      if( .not. &
      &  ( present(pcttrmm) .or. present(rtrmm) .or. present(trmm) ) &
      & )then
 
 
      if( .not.( present(wi) .or. present(swi) ) )then
       if( dwn )then
        sum1 = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         sum1 = sum1 + dble(xi(cnt))
        enddo
        mean = sum1/cnt
        sum2 = 0.
        cnt = 0
        cnd = 0
        sdev = 0.
        do while ( cnt < ndata )
         cnt = cnt + 1
         if( xi(cnt) <= mean )then
          cnd = cnd + 1
          sum2 = sum2 + (xi(cnt)-mean)**2
         endif
        enddo
        if( cnd > 1 )then
         sdev = sqrt(sum2/(cnd-1))
        elseif( cnd > 0 )then
         sdev = sqrt(sum2)
        endif
        if( sdev > 0. .and. cnd > 1 )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         sum1 = sum1 + dble(xi(cnt))
         sum2 = sum2 + dble(xi(cnt))**2
        enddo
        mean = sum1/cnt
        sdev = sqrt(max(0.d0,(sum2-sum1**2/cnt))/(cnt-1))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
      elseif( present(wi) )then
       if( dwn )then
        sum1 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         sumw = sumw + dble(wi(cnt))
         sum1 = sum1 + dble(wi(cnt))*dble(xi(cnt))
        enddo
        mean = sum1/sumw
        sum2 = 0.
        sumw = 0.
        cnt = 0
        cnd = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         if( xi(cnt) <= mean )then
          cnd = cnd + 1
          sumw = sumw + dble(wi(cnt))
          sum2 = sum2 + dble(wi(cnt))*dble(xi(cnt)-mean)**2
         endif
        enddo
        if( cnd > 1 )then
         sdev = sqrt(sum2/(sumw*(1.-1./cnd)))
        elseif( cnd > 0 )then
         sdev = sqrt(sum2/sumw)
        endif
        if( sdev > 0. .and. cnd > 1 )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         sumw = sumw + dble(wi(cnt))
         sum1 = sum1 + dble(wi(cnt))*dble(xi(cnt))
         sum2 = sum2 + dble(wi(cnt))*dble(xi(cnt))**2
        enddo
        mean = sum1/sumw
        sdev = sqrt(max(0.d0,(sum2-sum1**2/sumw))/(sumw*(1.-1./cnt)))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
      elseif( present(swi) )then
       if( dwn )then
        sum1 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         swi2 = 1./dble(swi(cnt))**2
         sumw = sumw + swi2
         sum1 = sum1 + dble(xi(cnt))*swi2
        enddo
        mean = sum1/sumw
        sum2 = 0.
        sumw = 0.
        cnt = 0
        cnd = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         if( xi(cnt) <= mean )then
          swi2 = 1./dble(swi(cnt))**2
          sumw = sumw + swi2
          sum2 = sum2 + dble(xi(cnt)-mean)**2*swi2
         endif
        enddo
        if( cnd > 1 )then
         sdev = sqrt(sum2/(sumw*(1.-1./cnd)))
        elseif( cnd > 0 )then
         sdev = sqrt(sum2/sumw)
        endif
        if( sdev > 0. .and. cnd > 1 )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata )
         cnt = cnt + 1
         swi2 = 1./dble(swi(cnt))**2
         sumw = sumw + swi2
         sum1 = sum1 + dble(xi(cnt))*swi2
         sum2 = sum2 + dble(xi(cnt))**2*swi2
        enddo
        mean = sum1/sumw
        sdev = sqrt(max(0.d0,(sum2-sum1**2/sumw))/(sumw*(1.-1./cnt)))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
      endif
 
      else  !  trmm branch, trmm true
 
       allocate(x(1:ndata))
       x(1:ndata) = xi(1:ndata)
 
       ntrmm = 0
       if( present(pcttrmm) )then
         ntrmm = pcttrmm*ndata/100.
       endif
       if( present(rtrmm) )then
         ntrmm = rtrmm*ndata
       endif
       if( present(trmm) )then
         ntrmm = trmm
       endif
       if( ntrmm > 0 )then
        if( ndata > 0 )then
         if( present(wi) )then
          allocate(w(1:ndata))
          w(1:ndata) = wi(1:ndata)
          call rank(x(1:ndata),r=w(1:ndata))
         elseif( present(swi) )then
          allocate(sw(1:ndata))
          sw(1:ndata) = swi(1:ndata)
          call rank(x(1:ndata),r=sw(1:ndata))
         else
          call rank(x(1:ndata))
         endif
        endif
       endif
 
 
      if( .not.( present(wi) .or. present(swi) ) )then
       if( dwn )then
        sum1 = 0.
        cnt = 0
        do while ( cnt < ndata -2*ntrmm )
         cnt = cnt + 1
         sum1 = sum1 + dble(x(ntrmm+cnt))
        enddo
        mean = sum1/cnt
        cnt = 0
        cnd = 0
        sum2 = 0.
        sdev = 0.
        do while ( cnt < ndata - 2*ntrmm )
         cnt = cnt + 1
         if( x(ntrmm+cnt) <= mean )then
          sum2 = sum2 + (dble(x(ntrmm+cnt))-dble(mean))**2
          cnd = cnd + 1
         endif
        enddo
        if( cnd > 1 )then
         sdev = sqrt(sum2/(cnd-1))
        elseif( cnd > 0 )then
         sdev = sqrt(sum2)
        endif
        if( cnd > 1 .and. sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        cnt = 0
        do while ( cnt < ndata -2*ntrmm)
         cnt = cnt + 1
         sum1 = sum1 + dble(x(ntrmm+cnt))
         sum2 = sum2 + dble(x(ntrmm+cnt))**2
        enddo
        mean = sum1/cnt
        sdev = sqrt((sum2-sum1**2/cnt)/(cnt-1))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
      elseif( present(wi) )then
       if( dwn )then
        sum1 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         sumw = sumw + dble(w(ntrmm+cnt))
         sum1 = sum1 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt))
        enddo
        mean = sum1/sumw
        sumw = 0.
        sum2 = 0.
        cnt = 0
        cnd = 0
        sdev = 0.
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         if( x(ntrmm+cnt) <= mean )then
          cnd = cnd + 1
          sumw = sumw + dble(w(ntrmm+cnt))
          sum2 = sum2 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt)-mean)**2
         endif
        enddo
        if( sumw > 0. .and. cnd > 1 )then
         sdev = sqrt(sum2/(sumw*(1.-1./cnd)))
        elseif( sumw > 0. )then
         sdev = sqrt(sum2/sumw)
        endif
        if( sdev > 0. .and. cnd > 1 )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         sumw = sumw + dble(w(ntrmm+cnt))
         sum1 = sum1 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt))
         sum2 = sum2 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt))**2
        enddo
        mean = sum1/sumw
        sdev = sqrt((sum2-sum1**2/sumw)/(sumw*(1.-1./cnt)))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
       deallocate(w)
      elseif( present(swi) )then
       if( dwn )then
        sum1 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         swi2 = 1./sw(ntrmm+cnt)**2
         sumw = sumw + swi2
         sum1 = sum1 + swi2*dble(x(ntrmm+cnt))
        enddo
        mean = sum1/sumw
        sumw = 0.
        sum2 = 0.
        cnt = 0
        cnd = 0
        sdev = 0.
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         if( x(ntrmm+cnt) <= mean )then
          cnd = cnd + 1
          swi2 = 1./sw(ntrmm+cnt)**2
          sumw = sumw + swi2
          sum2 = sum2 + swi2*dble(x(ntrmm+cnt)-mean)**2
         endif
        enddo
        if( sumw > 0. .and. cnd > 1 )then
         sdev = sqrt(sum2/(sumw*(1.-1./cnd)))
        elseif( sumw > 0. )then
         sdev = sqrt(sum2/sumw)
        endif
        if( sdev > 0. .and. cnd > 1 )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       else
        sum1 = 0.
        sum2 = 0.
        sumw = 0.
        cnt = 0
        do while ( cnt < ndata-2*ntrmm )
         cnt = cnt + 1
         sumw = sumw + dble(w(ntrmm+cnt))
         sum1 = sum1 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt))
         sum2 = sum2 + dble(w(ntrmm+cnt))*dble(x(ntrmm+cnt))**2
        enddo
        mean = sum1/sumw
        sdev = sqrt((sum2-sum1**2/sumw)/(sumw*(1.-1./cnt)))
        if( sdev > 0. )then
         tprob = qrobt(sqrt(real(cnt))*mean/sdev,cnt-1)
        else
         tprob = 0.
        endif
       endif
       deallocate(sw)
      endif
 
      deallocate(x)
 
      endif  !  end trmm branch

      return
 
      end
