      module mrank

      use datecompare
      use mpmodule
      use mpmodulev
      implicit none

      type cchar
       integer l
       character(len = 1), pointer :: p
      end type

      type ssym
       integer l
       integer x
       character(len = 1), pointer :: p
      end type

      integer rank_mode

      interface rank
       module procedure rank_r,rank_dp,rank_i,rank_cx,&
       & rank_dcx,rank_ch,rank_dt,rank_mp,rank_s,rank_ii
      end interface

        contains

      subroutine rank_r(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      real :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)


      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_r

      subroutine rank_i(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      integer :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_i

      subroutine rank_ii(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      integer(kind=8) :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_ii

      subroutine rank_dp(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      double precision :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_dp

      subroutine rank_cx(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      complex :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(abs(a(ia)) > abs(aa))then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(abs(a(l+1)).gt.abs(a(ir)))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(abs(a(l)).gt.abs(a(ir)))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(abs(a(l+1)).gt.abs(a(l)))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( abs(a(ia)) < abs(aa) )
          ia=ia+1
         enddo
         j=j-1
         do while ( abs(a(j)) > abs(aa) )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_cx

      subroutine rank_dcx(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      double complex :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(abs(a(ia)) > abs(aa))then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(abs(a(l+1)).gt.abs(a(ir)))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(abs(a(l)).gt.abs(a(ir)))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(abs(a(l+1)).gt.abs(a(l)))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( abs(a(ia)) < abs(aa) )
          ia=ia+1
         enddo
         j=j-1
         do while ( abs(a(j)) > abs(aa) )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_dcx

      subroutine rank_ch(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      type(cchar) a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia)%p(1:a(ia)%l) > aa%p(1:aa%l))then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1)%p(1:a(l+1)%l).gt.a(ir)%p(1:a(ir)%l))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l)%p(1:a(l)%l).gt.a(ir)%p(1:a(ir)%l))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1)%p(1:a(l+1)%l).gt.a(l)%p(1:a(l)%l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia)%p(1:a(ia)%l) < aa%p(1:aa%l) )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j)%p(1:a(j)%l) > aa%p(1:aa%l) )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_ch

      subroutine rank_s(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      type(ssym) a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if( rrank_s(a(ia),aa) )then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if( rrank_s(a(l+1),a(ir)) )then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if( rrank_s(a(l),a(ir)) )then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if( rrank_s(a(l+1),a(l)) )then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( rrank_s(aa,a(ia)) )
          ia=ia+1
         enddo
         j=j-1
         do while ( rrank_s(a(j),aa) )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_s

      subroutine rank_dt(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      type(datemdy) :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_dt

      subroutine rank_mp(a,r,i,ii,d,c,dc,ch,dt,mpr,ss,mrk)
      integer, optional :: mrk
      integer m,istk,nstk,l,ir,ia,iq,j,ix
      real fx,fm,fa,fc,fmi
      parameter (m=7,nstk=100,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)
      type(mp_real) :: a(:),aa,aa1
      integer n,ibb,ibb1,stack(nstk)

      real, optional :: r(:)
      integer, optional :: i(:)
      integer(kind=8), optional :: ii(:)
      double precision, optional :: d(:)
      complex, optional :: c(:)
      double complex, optional :: dc(:)
      type(cchar), optional :: ch(:)
      type(datemdy), optional :: dt(:)
      type(mp_real), optional :: mpr(:)
      type(ssym), optional :: ss(:)

      logical :: lopt=.false.
      real, allocatable :: wr(:)
      integer, allocatable :: wi(:),idx(:)
      integer(kind=8), allocatable :: wii(:)
      double precision, allocatable :: wd(:)
      complex, allocatable :: wc(:)
      double complex, allocatable :: wdc(:)
      type(cchar), allocatable :: wch(:)
      type(datemdy), allocatable :: wdt(:)
      type(mp_real), allocatable :: wmpr(:)
      type(ssym), allocatable :: wss(:)

      n = size(a,1)
      rank_mode = 1
      if( present(mrk) )then
       rank_mode = mrk
      endif

      lopt=present(r) .or. present(i) .or. present(d) .or. present(c) &
      & .or. present(dc) .or. present(ch) .or. present(dt) .or. present(mpr) &
      & .or. present(ii) .or. present(ss)
      if( n > 0 .and. lopt )then
       allocate(idx(n))
       idx(1:n) = (/(j,j=1,n)/)
      endif

      istk=0
      l=1
      ir=n
      fx=0.
      do while(n>0)
      if(ir-l.lt.m)then
       do j=l+1,ir
        aa=a(j)
        if( lopt )then
          ibb=idx(j)
        endif
          ix = l - 1
          do ia=j-1,l,-1
            if(a(ia) > aa)then
             a(ia+1)=a(ia)
                 if( lopt )then
              idx(ia+1)=idx(ia)
                 endif
            else
             ix=ia
             exit
            endif
          enddo
          a(ix+1)=aa
          if( lopt )then
           idx(ix+1)=ibb
          endif
       enddo
       if(istk.eq.0)then
        if( lopt )then
          if( present(r) )then
           allocate(wr(n))
           wr(1:n) = r(1:n)
           r(1:n) = wr(idx(1:n))
           deallocate(wr)
          endif
          if(present(i))then
           allocate(wi(n))
           wi(1:n) = i(1:n)
           i(1:n) = wi(idx(1:n))
           deallocate(wi)
          endif
          if(present(ii))then
           allocate(wii(n))
           wii(1:n) = ii(1:n)
           ii(1:n) = wii(idx(1:n))
           deallocate(wii)
          endif
          if( present(d) )then
           allocate(wd(n))
           wd(1:n) = d(1:n)
           d(1:n) = wd(idx(1:n))
           deallocate(wd)
          endif
          if( present(c) )then
           allocate(wc(n))
           wc(1:n) = c(1:n)
           c(1:n) = wc(idx(1:n))
           deallocate(wc)
          endif
          if( present(dc) )then
           allocate(wdc(n))
           wdc(1:n) = dc(1:n)
           dc(1:n) = wdc(idx(1:n))
           deallocate(wdc)
          endif
          if( present(ch) )then
           allocate(wch(n))
           wch(1:n) = ch(1:n)
           ch(1:n) = wch(idx(1:n))
           deallocate(wch)
          endif
          if( present(dt) )then
           allocate(wdt(n))
           wdt(1:n) = dt(1:n)
           dt(1:n) = wdt(idx(1:n))
           deallocate(wdt)
          endif
          if( present(mpr) )then
           allocate(wmpr(n))
           wmpr(1:n) = mpr(1:n)
           mpr(1:n) = wmpr(idx(1:n))
           deallocate(wmpr)
          endif
          if( present(ss) )then
           allocate(wss(n))
           wss(1:n) = ss(1:n)
           ss(1:n) = wss(idx(1:n))
           deallocate(wss)
          endif
         deallocate(idx)
        endif
        return
       endif
       ir=stack(istk)
       l=stack(istk-1)
       istk=istk-2
      else
       ia=l
       j=ir
       fx=mod(fx*fa+fc,fm)
       iq=(fx*fmi)*(ir-l-3)+l+2
        aa1=a(iq)
        a(iq)=a(l+1)
        a(l+1)=aa1
        if( lopt )then
         ibb1 = idx(iq)
         idx(iq) = idx(l+1)
         idx(l+1) = ibb1
        endif
        if(a(l+1).gt.a(ir))then
         aa1=a(l+1)
         a(l+1)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l+1)
          idx(l+1) = ibb
         endif
        endif
        if(a(l).gt.a(ir))then
         aa1=a(l)
         a(l)=a(ir)
         a(ir)=aa1
         if( lopt )then
          ibb = idx(ir)
          idx(ir) = idx(l)
          idx(l) = ibb
         endif
        endif
        if(a(l+1).gt.a(l))then
         aa1=a(l+1)
         a(l+1)=a(l)
         a(l)=aa1
           if( lopt )then
            ibb1 = idx(l+1)
            idx(l+1) = idx(l)
            idx(l) = ibb1
           endif
        endif
        ia=l+1
        j=ir
        aa=a(l)
        if( lopt )then
         ibb = idx(l)
        endif
        do
         ia = ia + 1
         do while ( a(ia) < aa )
          ia=ia+1
         enddo
         j=j-1
         do while ( a(j) > aa )
          j = j - 1
         enddo
         if(j.lt.ia)then
          exit
         endif
         aa1=a(ia)
         a(ia)=a(j)
         a(j)=aa1
         if( lopt )then
          ibb1 = idx(ia)
          idx(ia) = idx(j)
          idx(j) = ibb1
         endif
        enddo
        a(l)=a(j)
        a(j)=aa
        if( lopt )then
         idx(l) = idx(j)
         idx(j) = ibb
        endif
       istk=istk+2
        if(ir-ia+1.ge.j-l)then
          stack(istk)=ir
          stack(istk-1)=ia
          ir=j-1
        else
          stack(istk)=j-1
          stack(istk-1)=l
          l=ia
        endif
      endif
      enddo
      return
      end subroutine rank_mp

      logical function rrank_s(x,y)
       type(ssym) x,y
       rrank_s = .false.
       if( rank_mode == 1 )then
         rrank_s = ( x%p(1:x%l) > y%p(1:y%l) )
       elseif( rank_mode == 2 )then
         rrank_s = ( x%x > y%x )
       endif
       return
      end function rrank_s

      end module mrank
