      integer function mtxinv(a,atau,rtau)
      implicit none
      integer m,n
      real a(:,:)
      real, intent(in), optional :: atau,rtau
      real, allocatable :: t1(:,:)

      interface
       subroutine dmtrx(mx,d1,dv)
       real,intent(out) :: mx(:,:)
       real, optional,intent(in) :: d1,dv(:)
       end subroutine dmtrx
             integer function lusolve(a,m,b,n,piv,atau,rtau)
              integer m,n
              integer, optional :: piv(2,m-1)
              real, optional :: atau,rtau
              real a(m,m),b(m,n)
             end function lusolve
      end interface

      m = size(a,1)
      n = size(a,2)
      if( m /= n )then
       a = 0.
       return
      endif

      mtxinv = 0

      allocate(t1(n,n))
      t1 = a
      call dmtrx(a(1:n,1:n),d1=1.)
      if( present(atau) )then
       mtxinv = lusolve(t1,n,a,n,atau=atau)
      elseif( present(rtau) )then
       mtxinv = lusolve(t1,n,a,n,rtau=rtau)
      else
       mtxinv = lusolve(t1,n,a,n)
      endif
      deallocate(t1)
      return
      end function mtxinv
