      module rarith

      use smparith
      implicit none

      type rational
       integer nxn
       integer nxd
       type(smprec) n
       type(smprec) d
      end type rational

      integer :: ratmax = 0
         logical :: ratmax_warning = .true.

      integer, private :: i,isy,j,ld,ln,lnx,lx

      type(smprec) ratcompare_s1,ratcompare_s2

      character(len=1),target :: ratplusfcn_nc(8192),ratsbtrfcn_nc(8192),&
      &ratmultfcn_nc(8192),ratdvdefcn_nc(8192),ratplusfcn_dc(8192),&
      &ratsbtrfcn_dc(8192),ratmultfcn_dc(8192),ratdvdefcn_dc(8192),&
      &ratcompare_s1_c(8192),ratcompare_s2_c(8192)

      save ratplusfcn_nc,ratsbtrfcn_nc,ratmultfcn_nc,ratdvdefcn_nc,&
      &ratplusfcn_dc,ratsbtrfcn_dc,ratmultfcn_dc,ratdvdefcn_dc,ratmax,&
      &ratcompare_s1_c,ratcompare_s2_c

      interface assignment( = )
        module procedure set_rational
      end interface

      interface operator( + )
        module procedure plus_rational
      end interface

      interface operator( - )
        module procedure sbtr_rational
      end interface

      interface operator( * )
        module procedure mult_rational
      end interface

      interface operator( / )
        module procedure dvde_rational
      end interface

      interface operator( .lt. )
         module procedure lt_rational
      end interface

      interface operator( .le. )
         module procedure le_rational
      end interface

      interface operator( .gt. )
         module procedure gt_rational
      end interface

      interface operator( .ge. )
         module procedure ge_rational
      end interface

      interface operator( .eq. )
         module procedure eq_rational
      end interface

      interface operator( .ne. )
         module procedure ne_rational
      end interface

      interface operator( .mlt. )
         module procedure mlt_rational
      end interface

      interface operator( .mle. )
         module procedure mle_rational
      end interface

      interface operator( .mgt. )
         module procedure mgt_rational
      end interface

      interface operator( .mge. )
         module procedure mge_rational
      end interface

      interface operator( .meq. )
         module procedure meq_rational
      end interface

      interface operator( .mne. )
         module procedure mne_rational
      end interface

      contains

      subroutine set_rational(a,b)
      type(rational),intent(out) :: a
      type(rational),intent(in) :: b
      a%n = b%n  !  this is uses the smparith assignment to do the job
      a%d = b%d  !   the way we want it done
      a%nxn = b%nxn  !  assumes b is in proper form
      a%nxd = b%nxd  !  (i.e., one of nxn or nxd = 0)
      return
      end subroutine set_rational

      type(rational) function plus_rational(b,c) result(a)
      use smparith
      type(rational),intent(in):: b,c
      type(smprec) t1,t2
      character(len=1),target :: t1_c(8192),t2_c(8192)
      integer i,as,m1,m2,mn12
!      write(*,*)'b%nxn,b%nxd',b%nxn,b%nxd
!      write(*,*)'c%nxn,c%nxd',c%nxn,c%nxd
!      call displayr(b,'b')
!      call displayr(c,'c')
      a%n%m=>ratplusfcn_nc(1)
      a%d%m=>ratplusfcn_dc(1)
      a%n%x=8192
      a%d%x=8192
      t1%m=>t1_c(1)
      t2%m=>t2_c(1)
      t1%x=8192
      t2%x=8192
      t1 = b%n*c%d
      t2 = b%d*c%n
      m1 = b%nxn + c%nxd
      m2 = b%nxd + c%nxn
      mn12 = min(m1,m2)
!      write(*,*)'m1,m2,mn12',m2,m2,mn12
!  expand the bigger one of the two
      do i=1,m1-mn12
       t1%l=t1%l+1
       t1%m(t1%l:t1%l)=char(0)
      enddo
      do i=1,m2-mn12
       t2%l=t2%l+1
       t2%m(t2%l:t2%l)=char(0)
      enddo
!      call display(t1,'t1')
!      call display(t2,'t2')
      a%n = t1 + t2
      a%nxn = mn12  !  and set number extra digits to min of the two
!      call display(a%n,'an')
      a%d = b%d*c%d
      a%nxd = b%nxd + c%nxd
      as = a%n%s*a%d%s
      a%n%s = 1
      a%d%s = 1
!      call display(a%d,'ad')
      call euclid(a)   
      a%n%s = as
!      call displayr(a,'afer euclid a')
      return
      end function plus_rational

      type(rational) function sbtr_rational(b,c) result(a)
      use smparith
      type(rational),intent(in):: b,c
      type(smprec) t1,t2
      character(len=1),target :: t1_c(8192),t2_c(8192)
      integer i,as,m1,m2,mn12
      t1%m=>t1_c(1)
      t2%m=>t2_c(1)
      t1%x=8192
      t2%x=8192
      a%n%m=>ratsbtrfcn_nc(1)
      a%d%m=>ratsbtrfcn_dc(1)
      a%n%x=8192
      a%d%x=8192
      t1 = b%n*c%d
      t2 = b%d*c%n
      m1 = b%nxn + c%nxd
      m2 = b%nxd + c%nxn
      mn12 = min(m1,m2)
!  expand the bigger one of the two
      do i=1,m1-mn12
       t1%l=t1%l+1
       t1%m(t1%l:t1%l)=char(0)
      enddo
      do i=1,m2-mn12
       t2%l=t2%l+1
       t2%m(t2%l:t2%l)=char(0)
      enddo
      a%n = t1 - t2
      a%nxn = mn12
      a%d = b%d*c%d
      a%nxd = b%nxd + c%nxd
      as = a%n%s*a%d%s
      a%n%s = 1
      a%d%s = 1
      call euclid(a)
      a%n%s = as
      return
      end function sbtr_rational

      type(rational) function mult_rational(b,c) result(a)
      use smparith
      type(rational), intent(in):: b,c 
      integer as
      a%n%m=>ratmultfcn_nc(1)
      a%d%m=>ratmultfcn_dc(1)
      a%n%x=8192
      a%d%x=8192
      a%nxn = b%nxn+c%nxn
      a%nxd = b%nxd+c%nxd
      a%n = b%n*c%n
      a%d = b%d*c%d
      as = a%n%s*a%d%s
      a%n%s = 1
      a%d%s = 1
      call euclid(a)
      a%n%s = as
      return
      end function mult_rational

      type(rational) function dvde_rational(b,c) result(a)
      use smparith
      type(rational), intent(in):: b,c 
      integer as
      a%n%m=>ratdvdefcn_nc(1)
      a%d%m=>ratdvdefcn_dc(1)
      a%n%x=8192
      a%d%x=8192
      a%nxn = b%nxn+c%nxd
      a%nxd = b%nxd+c%nxn
      a%n = b%n*c%d
      a%d = b%d*c%n
      as = a%n%s*a%d%s
      a%n%s = 1
      a%d%s = 1
      call euclid(a)
      a%n%s = as
      return
      end function dvde_rational

      subroutine euclid(a)
!  euclid does two functions:
!    (1)  reduces rational number to lowest form
!    (2)  trims numerator and denominator to ratmax digits, and
!         adjusts nxn and nxd accordingly, if ratmax > 0
      use smparith
      integer i
      type(rational) a
      type(smprec) rm,r6,r5,q
      character(len=1),target::rm_c(8192),r6_c(8192),r5_c(8192),q_c(8192)
      rm%x=8192
      r6%x=8192
      r5%x=8192
      q%x=8192
      rm%m=>rm_c(1)
      r6%m=>r6_c(1)
      r5%m=>r5_c(1)
      q%m=>q_c(1)
      if( a%d  .meq. zero_smp )then
       return
      endif

    if( ratmax > 0 )then   !   adjust nxn and nxd only when ratmax > 0
      if( ratmax_warning )then
          ratmax_warning = .false.
          write(0,*)'warning: ratmax > 0 (not a good thing to do)'
         endif
      if( a%n .meq. zero_smp )then
       a%nxn = 0
      else
!       write(*,*)'adjusting a%n%l for trailing zeros'
       i = a%n%l
!       write(*,*)'starting i',i
       do while ( a%n%m(i:i) == char(0) .and. i > 1 )
!        write(*,*)'decrementing i'
        i = i - 1
        a%nxn = a%nxn + 1
       enddo
       a%n%l = i
!       write(*,*)'final i',i
      endif
!      write(*,*)'adjusting a%d%l for trailing zeros'
      i = a%d%l
!      write(*,*)'starting i',i
      do while ( a%d%m(i:i) == char(0) .and. i > 1 )
!       write(*,*)'decrementing i'
       i = i - 1
       a%nxd = a%nxd + 1
      enddo
      a%d%l = i
!      write(*,*)'final i',i
    endif

      r6=a%d
      r6%s=1
      r5=a%n
      r5%s=1
!      call display(r5,'r5 ')
!      call display(r6,'r6 ')
10    call smpdiv(q,rm,r5,r6)
!      call display(q,'q ')
!      call display(rm,'rm ')
      r5=r6
      r6=rm
!      call display(r5,'r5 ')
!      call display(r6,'r6 ')
      if(rm .mne. zero_smp)go to 10
      a%n = a%n/r5
      call smpzstrip(a%n,0)
      a%d = a%d/r5
      call smpzstrip(a%d,0)
      select case(ratmax)
      case(1:)
       if( ratmax_warning )then
           ratmax_warning = .false.
           write(0,*)'warning: ratmax > 0 (not a good thing to do)'
          endif
       if( a%n%l > ratmax )then
        a%nxn = a%nxn + a%n%l - ratmax
        a%n%l = ratmax
       endif
       if( a%d%l > ratmax )then
        a%nxd = a%nxd + a%d%l - ratmax
        a%d%l = ratmax
       endif
       if( a%nxn*a%nxd /= 0 )then
        select case(a%nxn-a%nxd)
        case(:-1)
         a%nxd = -(a%nxn-a%nxd)
         a%nxn = 0
        case(0)
         a%nxn = 0
         a%nxd = 0
        case(1:)
         a%nxn = (a%nxn-a%nxd)
         a%nxd = 0
        end select
       endif
      case default
       a%nxn = 0
       a%nxd = 0
      end select
      return
      end subroutine euclid

      subroutine displayr(a,label)
      type(rational) a
      type(smprec) sn,sd,tn,td
      character(len=*) label
      character(len=10000) oline
      character(len=1),target::sn_c(8192),sd_c(8192),tn_c(8192),td_c(8192)
      integer ll,k,j,i
      sn%m=>sn_c(1)
      sd%m=>sd_c(1)
      sn%x=8192
      sd%x=8192
      tn%m=>tn_c(1)
      td%m=>td_c(1)
      tn%x=8192
      td%x=8192
      tn = a%n
      td = a%d
!      write(*,*)'a%nxn,a%nxd',a%nxn,a%nxd
!      call display(tn,'tn before expansion')
!      call display(td,'td before expansion')
!   expand whichever one needs it
      do i = 1,a%nxn
       tn%l = tn%l + 1
       tn%m(tn%l:tn%l) = char(0)
      enddo
      do i = 1,a%nxd
       td%l = td%l + 1
       td%m(td%l:td%l) = char(0)
      enddo

!      call display(tn,'tn after expansion')
!      call display(td,'td after expansion')

       call smp2dfr(tn,sn)
       call smp2dfr(td,sd)
       ll = len_trim(label)
       k = 0
       do j = 1,ll
        k = k + 1
        oline(k:k) = label(j:j)
       enddo
       if( k > 0 )then
        k = k + 1
        oline(k:k) = " "
       endif
       do j = 1,sn%l
        k = k + 1
        oline(k:k) = sn%m(j:j)
       enddo
       k = k + 1
       oline(k:k) = '/'
       do j = 1,sd%l
        k = k + 1
        oline(k:k) = sd%m(j:j)
       enddo
       write(*,'(a)')oline(1:k)
      return
      end subroutine displayr

      logical function lt_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      lt_rational = ( ratcompare_s1 .lt. ratcompare_s2 )
      return
      end function lt_rational

      logical function le_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      le_rational = ( ratcompare_s1 .le. ratcompare_s2 )
      return
      end function le_rational

      logical function gt_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      gt_rational = ( ratcompare_s1 .gt. ratcompare_s2 )
      return
      end function gt_rational

      logical function ge_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      ge_rational = ( ratcompare_s1 .ge. ratcompare_s2 )
      return
      end function ge_rational

      logical function eq_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      eq_rational = ( ratcompare_s1 .eq. ratcompare_s2 )
      return
      end function eq_rational

      logical function ne_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      ne_rational = ( ratcompare_s1 .ne. ratcompare_s2 )
      return
      end function ne_rational

      logical function meq_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      meq_rational = ( ratcompare_s1 .meq. ratcompare_s2 )
      return
      end function meq_rational

      logical function mlt_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d /= 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      mlt_rational = ( ratcompare_s1 .mlt. ratcompare_s2 )
      return
      end function mlt_rational

      logical function mle_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d /= 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      mle_rational = ( ratcompare_s1 .mle. ratcompare_s2 )
      return
      end function mle_rational

      logical function mgt_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d /= 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      mgt_rational = ( ratcompare_s1 .mgt. ratcompare_s2 )
      return
      end function mgt_rational

      logical function mge_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d /= 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      mge_rational = ( ratcompare_s1 .mge. ratcompare_s2 )
      return
      end function mge_rational

      logical function mne_rational(a,b)
      type(rational),intent(in) :: a
      type(rational),intent(in) :: b
      integer i
      ratcompare_s1%m=>ratcompare_s1_c(1)
      ratcompare_s2%m=>ratcompare_s2_c(1)
      ratcompare_s1%x=8192
      ratcompare_s2%x=8192
!   this logic depends on b%d and a%d > 0
      ratcompare_s1 = a%n*b%d
      ratcompare_s2 = b%n*a%d
      do i = 1,a%nxn+b%nxd
       ratcompare_s1%l = ratcompare_s1%l+1
       ratcompare_s1%m(ratcompare_s1%l:ratcompare_s1%l)=char(0)
      enddo
      do i = 1,b%nxn+a%nxd
       ratcompare_s2%l = ratcompare_s2%l+1
       ratcompare_s2%m(ratcompare_s2%l:ratcompare_s2%l)=char(0)
      enddo
      mne_rational = ( ratcompare_s1 .mne. ratcompare_s2 )
      return
      end function mne_rational

         subroutine fp2rat(x,y)
         type(rational)x
         real y,f
         integer e,j,i,nx
         integer :: ibb = 256
         real :: bb = 256.

!         write(*,*)'into fp2rat with ',y

         e = exponent(y)-24
         f = abs(scale(fraction(y),24))
!         write(*,*)e,f

     select case(ratmax)
     case(1:)
       if( ratmax_warning )then
           ratmax_warning = .false.
           write(0,*)'warning: ratmax > 0 (not a good thing to do)'
          endif

!   when ratmax is positive, we set nxn and nxd appropriately

         if( e > 0 )then
          nx = 1+(e-1)/8  ! number of extra digits in numerator
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%nxn = nx
          x%nxd = 0
          x%n%s = sign(1.,y)
          x%n%l = 3
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(ibb/2**(1+mod(e-1,8)))
         elseif( e < 0 )then
          nx = abs(e)/8  ! number of extra digits in denominator
          x%nxn = 0
          x%nxd = nx
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(2**mod(abs(e),8))
          x%n%l = 3
          x%n%s = sign(1.,y)
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
         else ! e = 0
          x%nxn = 0
          x%nxd = 0
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%n%l = 3
          x%n%s = sign(1.,y)
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(1)
         endif

      case default

!   when ratmax = 0, or is negative, then nxn and nxd = 0
!   and we actually get the extra digits in the numerator and denominator

         x%nxn = 0
         x%nxd = 0

         if( e > 0 )then
          nx = 1+(e-1)/8  ! number of extra digits in numerator
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          do i = 4,nx+3
           x%n%m(i:i) = char(0)
          enddo
          x%n%s = sign(1.,y)
          x%n%l = nx+3
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(ibb/2**(1+mod(e-1,8)))
         elseif( e < 0 )then
          nx = abs(e)/8  ! number of extra digits in denominator
          x%d%l = nx+1
          x%d%s = 1
          x%d%m(1:1) = char(2**mod(abs(e),8))
          do i = 2,nx+1
           x%d%m(i:i) = char(0)
          enddo
          x%n%l = 3
          x%n%s = sign(1.,y)
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
         else ! e = 0
          do j = 3,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%n%l = 3
          x%n%s = sign(1.,y)
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(1)
         endif


      end select

         call euclid(x)

         return
         end subroutine fp2rat

         subroutine dp2rat(x,y)
         type(rational)x
         double precision y,f
         integer e,j,i,nx
         integer :: ibb = 256
         double precision :: bb = 256.

!         write(*,*)'into dp2rat with ',y

         e = exponent(y)-53
         f = abs(scale(fraction(y),53))
!         write(*,*)e,f

     select case(ratmax)
     case(1:)
       if( ratmax_warning )then
           ratmax_warning = .false.
           write(0,*)'warning: ratmax > 0 (not a good thing to do)'
          endif

!   when ratmax is positive, we set nxn and nxd appropriately

         if( e > 0 )then
          nx = 1+(e-1)/8  ! number of extra digits in numerator
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%nxn = nx
          x%nxd = 0
          x%n%s = sign(1.d0,y)
          x%n%l = 7
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(ibb/2**(1+mod(e-1,8)))
         elseif( e < 0 )then
          nx = abs(e)/8  ! number of extra digits in denominator
          x%nxn = 0
          x%nxd = nx
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(2**mod(abs(e),8))
          x%n%l = 7
          x%n%s = sign(1.d0,y)
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
         else ! e = 0
          x%nxn = 0
          x%nxd = 0
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%n%l = 7
          x%n%s = sign(1.d0,y)
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(1)
         endif

      case default

!   when ratmax = 0, or is negative, then nxn and nxd = 0
!   and we actually get the extra digits in the numerator and denominator

         x%nxn = 0
         x%nxd = 0

         if( e > 0 )then
          nx = 1+(e-1)/8  ! number of extra digits in numerator
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          do i = 8,nx+7
           x%n%m(i:i) = char(0)
          enddo
          x%n%s = sign(1.d0,y)
          x%n%l = nx+7
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(ibb/2**(1+mod(e-1,8)))
         elseif( e < 0 )then
          nx = abs(e)/8  ! number of extra digits in denominator
          x%d%l = nx+1
          x%d%s = 1
          x%d%m(1:1) = char(2**mod(abs(e),8))
          do i = 2,nx+1
           x%d%m(i:i) = char(0)
          enddo
          x%n%l = 7
          x%n%s = sign(1.d0,y)
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
         else ! e = 0
          do j = 7,1,-1
           i = mod(f,bb)
           x%n%m(j:j) = char(i)
           f = aint(f/bb)
          enddo
          x%n%l = 7
          x%n%s = sign(1.d0,y)
          x%d%l = 1
          x%d%s = 1
          x%d%m(1:1) = char(1)
         endif


      end select

         call euclid(x)

         return
         end subroutine dp2rat

         
         subroutine rat2fp(y,xi)
         real y,bb
         integer smpsize,i
         parameter (smpsize=8192,bb=256.)
         type(rational)x,xi
         type(smprec)t
         character(len=1),target::t_c(smpsize),xn_c(8192),xd_c(8192)

         t%x = smpsize
         t%m => t_c(1)
         x%n%x = 8192
         x%d%x = 8192
         x%n%m => xn_c(1)
         x%d%m => xd_c(1)

         x = xi
!         call displayr(x,'x in: ')
         isy = x%n%s
         x%n%s = 1

!   expand numerator and denominator if required
         do i = 1,x%nxn
          x%n%l=x%n%l+1
          x%n%m(x%n%l:x%n%l) = char(0)
         enddo
         do i = 1,x%nxd
          x%d%l=x%d%l+1
          x%d%m(x%d%l:x%d%l) = char(0)
         enddo

         ln = x%n%l
         ld = x%d%l
         lx = max(0,ld+4-ln)
!         write(*,*)'lx ',lx
         lnx = ln + lx
         x%n%l = lnx
         do i = ln+1,x%n%l
          x%n%m(i:i) = char(0)
         enddo

!         call displayr(x,'x adjusted: ')


         t = x%n/x%d

!         call display(t,'t: ')

         y = ichar(t%m(1:1))
         do j = 2,t%l
          y = bb*y + ichar(t%m(j:j))
         enddo
         do i =1,lx
          y = y/bb
         enddo

         if( isy < 0 )then
          y = -y
         endif

         return

         end subroutine rat2fp


         subroutine rat2dp(y,xi)
         double precision y,bb
         integer smpsize
         parameter (smpsize=8192,bb=256.)
         type(rational)x,xi
         type(smprec)t
         character(len=1),target::t_c(smpsize),xn_c(8192),xd_c(8192)

         t%x = smpsize
         t%m => t_c(1)
         x%n%x = 8192
         x%d%x = 8192
         x%n%m => xn_c(1)
         x%d%m => xd_c(1)

         x = xi
!         call displayr(x,'x in: ')
         isy = x%n%s
         x%n%s = 1

!   expand numerator and denominator if required
         do i = 1,x%nxn
          x%n%l=x%n%l+1
          x%n%m(x%n%l:x%n%l) = char(0)
         enddo
         do i = 1,x%nxd
          x%d%l=x%d%l+1
          x%d%m(x%d%l:x%d%l) = char(0)
         enddo


         ln = x%n%l
         ld = x%d%l
         lx = max(0,ld+8-ln)
!         write(*,*)'lx ',lx
         lnx = ln + lx
         x%n%l = lnx
         do i = ln+1,x%n%l
          x%n%m(i:i) = char(0)
         enddo

!         call displayr(x,'x adjusted: ')


         t = x%n/x%d

!         call display(t,'t: ')

         y = ichar(t%m(1:1))
         do j = 2,t%l
          y = bb*y + ichar(t%m(j:j))
         enddo
         do i =1,lx
          y = y/bb
         enddo

         if( isy < 0 )then
          y = -y
         endif

         return

         end subroutine rat2dp

      subroutine irat(r,cstrng,lstrng)
      type(rational):: r
      character(len=*) cstrng
      integer lstrng,ix

      ix = index(cstrng(1:lstrng),'/')
!      write(*,*)cstrng(1:lstrng)
!      write(*,*)cstrng(1:ix-1)
!      write(*,*)cstrng(ix+1:lstrng)

      call inum(r%n,cstrng(1:ix-1),ix-1)
      call inum(r%d,cstrng(ix+1:lstrng),lstrng-ix)
      r%nxn = 0
      r%nxd = 0
      call euclid(r)  !  reduce and adjust nxn and nxd if needed

      return

      end subroutine irat

        subroutine ratsqrt(rx,x)
        integer smpsize,i,lx
        parameter(smpsize=8192)
        type(rational) x,rx,t
        character(len=1),target::tn_c(smpsize),td_c(smpsize)
        t%n%x=smpsize
        t%d%x=smpsize
        t%n%m=>tn_c(1)
        t%d%m=>td_c(1)

        t = x  !   grab the input 

!   expand t%n or t%d in preparation for the sqrts
        do i=1,t%nxn
         t%n%l=t%n%l+1
         t%n%m(t%n%l:t%n%l)=char(0)
        enddo
        do i=1,t%nxd
         t%d%l=t%d%l+1
         t%d%m(t%d%l:t%d%l)=char(0)
        enddo

        t%nxn = 0  ! these need to be zero now
        t%nxd = 0

        lx = max(ratmax,t%n%l,t%d%l)  !   now expand for the sqrts

        do i = t%n%l+1,t%n%l+lx
         t%n%m(i:i)=char(0)
        enddo
        t%n%l = t%n%l+lx

        do i = t%d%l+1,t%d%l+lx
         t%d%m(i:i)=char(0)
        enddo
        t%d%l = t%d%l+lx


        call smpsqrt(t%n,t%n)  ! get the sqrts
        call smpsqrt(t%d,t%d)

        call euclid(t)  !  trim and reduce the answer
        rx = t  !   and give it to rx

!        call displayr(rx,'returning rx = ')


        return
        end subroutine ratsqrt


      end module rarith
