    module rdline
     implicit none

! the 59 is for Intel Fortran reading from graphics window (10/22/2007)
! Intel Fortran iostatus_for_eof=59
! g95 iostatus_for_eof=109
! g95 iostatus_for_eof=-1 sometimes (already taken into account directly)
! g95 iostatus_past_eof=207
! f95 iostatus_for_eof=-1
! f95 iostatus_past_eof=5008 (fedora 14 and earlier)
! f95 iostatus_past_eof=5001
! 2/15/2012 changed test >= iostatus_past_eof so will work both F14 and F16
! from a file on the hard disk, we get -1.
! from a file on the CD drive, we get a line with length 1 and value char(26)
     integer :: readstat,bif(1000),eif(1000),niflds,linenumber(50),&
     & i_rdline,iostatus_for_eof=-1,length_rdline,iostatus_past_eof=5001
     integer :: cg_rdline,bdl_rdline,mxfld_rdline=1000,starchk_rdline=1
     character (len=4097) :: input_line = ' '
     character (len=10) :: delim_rdline(50) = 'none'
     logical :: blank_rdline(50) = .true.
     logical :: tabrp_rdline(50) = .true.
     logical :: change_rdline(50) = .true.
     character(len=1) :: tmpchar_rdline
     character (len=11) :: dlmi_rdline
     character (len=10) :: trm_rdline(50)=(/("   ",i_rdline=1,4),&
     &"...",("   ",i_rdline=1,45)/)
     logical :: unit_end_of_file(50) = (/(.false.,i_rdline=1,50)/)
     data linenumber/50*0/,bif/1000*1/,eif/1000*1/,niflds/0/,readstat/0/

      interface
       subroutine bedparsec(ciny,nyir,bfld,efld,mxfld,dlm,cg,bdl)
         implicit none
         character(len=*)ciny
         character(len=11)dlm
         integer nyir,mxfld,cg,bdl,bfld(mxfld),efld(mxfld)
       end subroutine bedparsec
      end interface

     contains

     integer function readline(iunit,nfldsi)
     integer iunit,lin,ix_rdline,nx_rdline,i_rdline,nflds,i,mxfld
     integer, optional :: nfldsi
     nflds = 1000
     if( present(nfldsi) )then
      nflds = nfldsi
     endif
99   if( iunit >= 0 )then
      length_rdline = 0
     else
      length_rdline = length_rdline + 1
      input_line(length_rdline:length_rdline) = " "
     endif
     read(abs(iunit),'(a)',iostat=readstat)input_line(length_rdline+1:)
     lin = len_trim(input_line)
     if( readstat == 0 .and. lin == 0 )then
      linenumber(abs(iunit)) = linenumber(abs(iunit)) + 1
      go to 99
     elseif( ( readstat == iostatus_for_eof &
     &                    .or.  &
     &         readstat >= iostatus_past_eof &
!     &                    .or.  & 
!     &         readstat == -1 &     with f95, -1 already there
     &       ) &
     &                       .or.  &
     &  ( readstat == 0 .and. input_line == trm_rdline(abs(iunit)) )  &
     &                       .or.  &
!                                 eof on cd drive
     &  ( readstat == 0 .and. lin == 1 .and. input_line(1:1) == char(26) ) &
     &     )then
      readline = -1
      if( .not. unit_end_of_file(abs(iunit)) )then
       unit_end_of_file(abs(iunit)) = .true.
       if( readstat == 0 .and. input_line == trm_rdline(abs(iunit)) )then
        linenumber(abs(iunit)) = linenumber(abs(iunit)) + 1
       endif
      endif
     elseif( readstat == 0 )then
      linenumber(abs(iunit)) = linenumber(abs(iunit)) + 1
      readline = lin
      if( tabrp_rdline(abs(iunit)) )then
       call tabrplce(input_line(1:lin))
      endif
      dlmi_rdline = " "
      if( delim_rdline(abs(iunit)) == "none"  )then
       if( blank_rdline(abs(iunit)) )then  !  default delimiter is " ,"
        dlmi_rdline=" ,"//char(0)
        bdl_rdline=1
        cg_rdline = 0
        if( change_rdline(abs(iunit)) )then
         cg_rdline = 1
        endif
       else  !  default, but no blanks
        dlmi_rdline=","//char(0)
        bdl_rdline=0
        cg_rdline=0
        if( change_rdline(abs(iunit)) )then
         cg_rdline=1
        endif
       endif
      else   !  specify exactly what you want 
!  if you want a blank and other things, the blank must not be last
!  if only blanks, set delim_rdline = " "
       i=len_trim(delim_rdline(abs(iunit)))
       if( i == 0 )then
        dlmi_rdline=" "//char(0)
        bdl_rdline = 1
       else
        dlmi_rdline=delim_rdline(abs(iunit))(1:i)//char(0)
        bdl_rdline=index(dlmi_rdline(1:i)," ")
       endif
       cg_rdline=0
       if( change_rdline(abs(iunit)) )then
        cg_rdline=1
       endif
      endif
      tmpchar_rdline = input_line(readline+1:readline+1)
      input_line(readline+1:readline+1)=char(0)
      mxfld = mxfld_rdline
      if( starchk_rdline == 0 )then
       mxfld = -mxfld
      endif
      call bedparsec(input_line(1:readline+1),niflds,bif(1:nflds),eif(1:nflds),&
      & mxfld,dlmi_rdline,cg_rdline,bdl_rdline)
      input_line(readline+1:readline+1)=tmpchar_rdline
     else
      write(0,'(a,i2,a,i6,a)')' input error on unit ',abs(iunit),&
      &' : iostat = ',readstat,'; input line was:'
      write(0,'(a)')trim(input_line)
      call exit(1)
     endif
     length_rdline = readline
     return
     end function readline

     end module rdline
